<template>
    <div class="card mb-3" style="max-width: 540px;">

        <ModalFullProduct
            v-if="isModalFullProductVisible"
            @closeModal="closeModalFullProduct"
            @addToBasketFull="addToBasket"
        >
            <img :src="product.photo" class="product-image-full" :alt="product.name">
            <h5 class="card-title">{{ product.name }} </h5>
            <p class="card-text"> Ціна: {{ product.price | formattedPrice}} грн</p>
            <p class="card-text"> Розмір: {{ product.size }}  </p>
            <p class="card-text"> {{ product.description }}  </p>
        </ModalFullProduct>

        <div class="row g-0">
            <div class="col-md-4">
                <img :src="product.photo" class="img-fluid rounded-start" :alt="product.name">
            </div>
            <div class="col-md-8">
                <div class="card-body">
                    <h5 class="card-title">{{ product.name }} </h5>
                    <p class="card-text"> Ціна: {{ product.price | formattedPrice}} грн</p>
                    <p class="card-text"> Розмір: {{ product.size }}  </p>
                </div>
            </div>
        </div>
        <div class="product-down">
            <router-link
                class="btn btn-sm btn-success"
                :to="{
                    name: 'edit',
                    params: {
                        id: product.id
                    }
                }"
            >
                Редагувати
            </router-link>
            <button
                class="btn btn-sm btn-warning"
                @click="deleteProduct"
            >Видалити</button>
            <button
                class="btn btn-sm btn-success"
                @click="showModalFullProduct"
            >Подивитися</button>
            <button
                class="btn btn-sm btn-success"
                @click="addToBasket"
            >Додати до кошика</button>
        </div>
    </div>
</template>

<script>
import {axiosInstance} from "@/services/api.js";
import {mapActions} from "vuex";
import formattedPrice from "@/filters/price-format.js";
import ModalFullProduct from "@/components/popup/ModalFullProduct.vue";

export default {
    name: "Product",
    components: {
        ModalFullProduct,
    },
    filters: {
        formattedPrice,
    },
    props: {
        product: {
            type: Object,
            required: true,
        }
    },
    data() {
      return {
          isModalFullProductVisible: false
      }
    },
    methods: {
        deleteProduct(){
            this.$emit('delete-product', this.product);
        },
        addToBasket() {
            this.$emit('send-product-id', this.product);
        },
        showModalFullProduct() {
            this.isModalFullProductVisible = true;
        },
        closeModalFullProduct() {
            this.isModalFullProductVisible = false;
        }
    },

}
</script>

<style lang="scss">
    .oneproduct {
        height: 200px;
        padding-left: 24px;
        padding-top: 24px;
        background: #FFFFFF;
        border-radius: 16px;
        display: flex;
        flex-direction: column;
    }

    .productimage {
        max-width: 100px;
    }

    .product-down {
        display: flex;
        justify-content: space-around;
        align-items: center;
        flex-wrap: wrap;
        padding-bottom: 10px;
    }

    .product-image-full {
        max-width: 300px;
    }
</style>
